<script setup lang="ts">
  import { getTranslatedProperty } from '@shopware-pwa/helpers-next';
  import { AggregationFilterEntityOption, ShopwareSearchParams } from '@shopware-pwa/types';
  import { ProductListingKey } from '~/helpers/injection';
  const { listingType } = inject(ProductListingKey)!;
  const { getAvailableFilters } = useListing({ listingType });

  const { t } = useI18n();

  const emits = defineEmits<{
    (e: 'update:modelValue', value: { [code: string]: any }): void;
  }>();

  const props = defineProps<{
    modelValue?: ShopwareSearchParams;
  }>();

  const tags = ref<{ key: string; label: string; data?: any; text?: string }[]>([]);

  defineExpose({
    tags,
  });

  const { getFormattedPrice } = usePrice();

  watch(
    () => [props.modelValue, getAvailableFilters.value],
    () => {
      const temp = [];
      if (!props.modelValue) return;
      if (props.modelValue.term) {
        temp.push({
          key: 'term',
          label: t('search'),
          text: props.modelValue.term,
        });
      }

      if (props.modelValue.manufacturer?.length) {
        const filter = getAvailableFilters.value.find((el) => el.code === 'manufacturer');
        const ids = props.modelValue.manufacturer as string[];
        const idsName = ids.reduce((prev: string[], id: string) => {
          const entity = filter?.entities?.find((x) => x.id === id);
          if (entity) {
            prev.push(getTranslatedProperty(entity, 'name'));
          }
          return prev;
        }, []);

        if (idsName.length) {
          temp.push({
            key: 'manufacturer',
            label: t(filter?.label || ''),
            text: idsName.join(', '),
            data: ids,
          });
        }
      }

      if (props.modelValue.properties?.length) {
        const ids = props.modelValue.properties as string[];
        const filters = getAvailableFilters.value.filter((el) => el.code === 'properties');
        filters.forEach((filter) => {
          const selectedOptions = filter.options?.filter((option) => ids.includes(option.id));
          if (selectedOptions?.length) {
            const idsName = selectedOptions?.map((option) => getTranslatedProperty(option, 'name'));
            temp.push({
              key: 'properties',
              label: t(filter?.label || ''),
              text: idsName?.join(', '),
              data: selectedOptions,
            });
          }
        });
      }

      if (
        props.modelValue['min-price'] !== undefined ||
        props.modelValue['max-price'] !== undefined
      ) {
        const min = props.modelValue?.['min-price'];
        const max = props.modelValue?.['max-price'];
        const filter = getAvailableFilters.value.find((el) => el.code === 'price');
        let text = '';
        if (!min && !max) text = '';
        if (!min && max) text = `(<= ${getFormattedPrice(max)})`;
        if (min && !max) text = `(>= ${getFormattedPrice(min)})`;
        if (min && max) {
          text = `(${getFormattedPrice(min)} - ${getFormattedPrice(max)})`;
        }
        temp.push({
          key: 'price',
          label: t(filter?.label || ''),
          text,
          data: { min, max },
        });
      }

      if (props.modelValue.rating !== undefined) {
        const filter = getAvailableFilters.value.find((el) => el.code === 'rating');
        temp.push({
          key: 'rating',
          label: t(filter?.label || ''),
          data: props.modelValue.rating,
        });
      }
      if (props.modelValue['shipping-free']) {
        const filter = getAvailableFilters.value.find((el) => el.code === 'shipping-free');
        temp.push({
          key: 'shipping-free',
          label: t(filter?.label || ''),
          data: props.modelValue['shipping-free'],
        });
      }
      tags.value = temp;
    },
    {
      immediate: true,
      deep: true,
    },
  );

  const clearFilter = (key: string, label: string, data: any) => {
    let value: { [code: string]: any };

    switch (key) {
      case 'term':
        value = {
          term: undefined,
        };
        break;
      case 'properties':
        value = {
          properties: (props.modelValue?.properties as string[])?.filter(
            (id) => !data.map((x: AggregationFilterEntityOption) => x.id).includes(id),
          ),
        };
        break;
      case 'manufacturer':
        value = {
          manufacturer: undefined,
        };
        break;
      case 'rating':
        value = {
          rating: undefined,
        };
        break;
      case 'price':
        value = {
          'min-price': undefined,
          'max-price': undefined,
        };
        break;
      case 'shipping-free': {
        value = {
          'shipping-free': undefined,
        };
        break;
      }
      default:
        value = {};
    }
    tags.value = tags.value.filter((tag) => tag.label !== label);
    emits('update:modelValue', value);
  };
</script>

<template>
  <div class="flex flex-wrap gap-2">
    <template v-for="{ key, label, text, data } of tags" :key="label">
      <div class="border-border flex items-center gap-1.5 rounded-full border px-3 py-2">
        <template v-if="key === 'rating'">
          <div class="flex">
            <SwRating :model-value="data" :hightest-score="data" size="small" disabled />
          </div>
        </template>
        <template v-else>
          <SwTooltip :content="text" position="top" width="scales" :disabled="!text">
            <p class="line-clamp-3 text-xs font-semibold capitalize">
              <span>{{ label }}</span>
              <span v-if="text">: {{ text }}</span>
            </p>
          </SwTooltip>
        </template>
        <button
          class="i-sw-solid:times-circle color-information-disabled h-4 w-4 flex-shrink-0"
          @click="clearFilter(key, label, data)"
        />
      </div>
    </template>
  </div>
</template>
